# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `mv` Chapter.
"""

# NAG Copyright 2017-2024.

from ..base import utils

distance_mat_2 = utils._EngineState._get_symbol('g03ebf')
distance_mat_2.restype = None
distance_mat_2.argtypes = (
    utils._BYREF_STRING, # Input, update(len=1).
    utils._BYREF_STRING, # Input, scal(len=1).
    utils._BYREF_STRING, # Input, stype(len=1).
    utils._BYREF_FLOAT64, # Input, p.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, l.
    utils._EngineFloat64ArrayType.c_type, # Input, x[ldx, l].
    utils._BYREF_INT, # Input, ldx.
    utils._EngineIntArrayType.c_type, # Input, isv[l].
    utils._EngineFloat64ArrayType.c_type, # Input, y[ldy, l].
    utils._BYREF_INT, # Input, ldy.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, sx[l].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, sy[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, d[m, n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of update.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of scal.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of stype.
)

gaussian_mixture_ld = utils._EngineState._get_symbol('g03gbf')
gaussian_mixture_ld.restype = None
gaussian_mixture_ld.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    utils._EngineIntArrayType.c_type, # Input, isx[m].
    utils._BYREF_INT, # Input, nvar.
    utils._BYREF_INT, # Input, ng.
    utils._BYREF_INT, # Input, popt.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, prob[lprob, *].
    utils._BYREF_INT, # Input, lprob.
    utils._BYREF_INT, # Input/Output, niter.
    utils._BYREF_INT, # Input, riter.
    utils._EngineFloat64ArrayType.c_type, # Output, w[ng].
    utils._EngineFloat64ArrayType.c_type, # Output, g[ldg, *].
    utils._BYREF_INT, # Input, ldg.
    utils._BYREF_INT, # Input, sopt.
    utils._EngineFloat64ArrayType.c_type, # Output, s[lds, sds, *].
    utils._BYREF_INT, # Input, lds.
    utils._BYREF_INT, # Input, sds.
    utils._EngineFloat64ArrayType.c_type, # Output, f[ldf, *].
    utils._BYREF_INT, # Input, ldf.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_FLOAT64, # Output, loglik.
    utils._BYREF_INT, # Input/Output, ifail.
)
