# -*- coding: utf-8 -*-
u"""
Examples for the ``glopt`` module.

``glopt`` - Global Optimization of a Function

Global optimization involves finding the absolute maximum or minimum
value of a function (the `objective function`) of several variables,
possibly subject to restrictions (defined by a set of bounds or
`constraint functions`) on the values of the variables.
Where submodule ``opt`` treats local nonlinear optimization problems as
well as convex optimization problems (for which local optima are by
definition also global), this module tries to handle finding global
optima of non-convex nonlinear optimization problems.
Such problems can be much harder to solve than local optimization
problems because it is difficult to determine whether a potential
optimum found is global, and because of the nonlocal methods required to
avoid becoming trapped near local optima.

This introduction is a brief guide to the subject of global
optimization, designed for the casual user.
For further details you may find it beneficial to consult a more
detailed text, see Neumaier (2004).
Furthermore, much of the material in [the E04 Introduction] is also
relevant in this context and it is strongly recommended that you read
[the E04 Introduction].

Some solvers in this module have been integrated in to the NAG
optimization modelling suite, which provides an easy-to-use and flexible
way of defining optimization problems among numerous solvers of the NAG
library.
All utility routines from the suite can be used to define a compatible
problem to be solved by the integrated solvers; see [the E04
Introduction] for more details.

For full information please refer to the NAG Library document

https://support.nag.com/numeric/nl/nagdoc_30.1/flhtml/e05/e05intro.html
"""

# NAG Copyright 2017-2024.

pass
